<?php
function sportnaptar_898_delete_cache_function() {
// Gyorsítótár törlése

    // Ha nem az adminisztrátori oldalon vagyunk, akkor egyszerűen kilép
    if (!is_admin()) { return false; }

    function recurseRmdir($dir) 
    {
        $files = array_diff(scandir($dir), array('.','..'));
        foreach ($files as $file) {
        (is_dir("$dir/$file")) ? recurseRmdir("$dir/$file") : unlink("$dir/$file");
        }
        return rmdir($dir);
    }


    $tilt    = array('index.html', '.', '..');
    $path    = SPORTNAPTAR_898_ROOT .DIRECTORY_SEPARATOR. 'cache';
    $folders = array('');

    // A cache mappa alatti mappák beolvasása
    $handle = @opendir($path);
    if ($handle) {
        while (false !== ($folder = readdir($handle))) {
            if ((!in_array($folder, $tilt)) and (is_dir($path .DIRECTORY_SEPARATOR. $folder))) {
                $folders[] = $folder;
            }  
        }            
    }
    
    // Minden mappában
    foreach ($folders as $folder) {
        // Töröljük a fájlokat 
        $handle = @opendir($path .DIRECTORY_SEPARATOR. $folder);
        if ($handle) {
            while (false !== ($file = readdir($handle))) {
                if ((!in_array($file, $tilt)) and (!is_dir($path .DIRECTORY_SEPARATOR. $folder .DIRECTORY_SEPARATOR. $file))) {
                    // Magát a mappát nem töröljük, mert úgyis létre kellene hozni
                    // Ugyencsak nem töröljük az index.html állományt, mert annak a mappában megléte biztonsági szempontból szükséges.
                    unlink($path .DIRECTORY_SEPARATOR. $folder .DIRECTORY_SEPARATOR. $file); 
                } else {
                    if ((!in_array($file, $tilt)) and (is_dir($path .DIRECTORY_SEPARATOR. $folder .DIRECTORY_SEPARATOR. $file))) {
                        recurseRmdir($path .DIRECTORY_SEPARATOR. $folder .DIRECTORY_SEPARATOR. $file);
                    }
                }
            }
        }
    }
    
    $result = array(
        'status'  => 1,
        'message' => __('All cache files deleted.', 'sportnaptar')
    );
    echo json_encode($result);
    wp_die();

}
// Az ajax funkció csak bejelentkezett felhasználó számára elérhető 
add_action( 'wp_ajax_sportnaptar_898_delete_cache_function', 'sportnaptar_898_delete_cache_function' );


function sportnaptar_898_load_event_function() {
    
    $status   = 1;
    $html     = '';
    $id       = null;
    $parent   = null;
    $template = '';
    
    if ((isset($_REQUEST['id'])) and (!empty($_REQUEST['id']))) {
        $id = sanitize_text_field($_REQUEST['id']);
    }
    if ((isset($_REQUEST['parent'])) and (!empty($_REQUEST['parent']))) {
        $parent = sanitize_text_field($_REQUEST['parent']);
    }
    if ((isset($_REQUEST['template'])) and (!empty($_REQUEST['template']))) {
        $template = sanitize_text_field($_REQUEST['template']);
    }

    if (empty($id) || empty($parent)) {
        $result = array(
            'status'  => 0,
            'error'   => __('ID or parent ID is empty!', 'sportnaptar')
        );
        echo json_encode($result);
        wp_die();
    }

    include_once( SPORTNAPTAR_898_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'cache.php');
    include_once( SPORTNAPTAR_898_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'template.php');
    // Osztály betöltése, ha kell
    if (!class_exists('JSportnaptar898_one')) {
        include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'one.php');
    }
    
    $defaults = sportnaptar_898_get_options();
    $options = array(
            'id' => $id,
            'template' => str_replace('list', 'one', $template) 
        );
    $options = wp_parse_args($options, $defaults);    
    
    $event = new JSportnaptar898_one($options, null, true);
    $html = $event->getContent();

    $options = array(
            'template' => $template . '/go-back.html',
            'script'   => 'onclick="sportnaptar_898_go_back(\''.$parent.'\');"',
            'text'     => __('Go back', 'sportnaptar')
        );
    $tmpl = new JTemplates($options);
    $button = $tmpl->prepareContent();
              
    $html = '<div id="item_'.$id.'" class="sportnaptar-display-item">' .
            $button . $html . $button .
            '</div>';              

    $result = array(
        'status'  => 1,
        'id'      => $id,
        'parent'  => $parent,  
        'html'    => $html
    );
    echo json_encode($result);
    wp_die();


}
add_action( 'wp_ajax_nopriv_sportnaptar_898_load_event_function', 'sportnaptar_898_load_event_function' );
add_action( 'wp_ajax_sportnaptar_898_load_event_function', 'sportnaptar_898_load_event_function' );

    
    