<?php
/*
Plugin Name: Sportnaptár
Plugin URI:  https://sportnaptar.hu/wordpress
Description: A http://sportnaptar.hu oldal bejegyzéseinek megjelenítése shortcode-on keresztül.
Version:     2.00
Author:      InfoScope Kft.
Author URI:  https://sportnaptar.hu/impresszum
License:     Minden jog fenntartva!
License URI: https://sportnaptar.hu/adatkezelesi-szabalyzat
Text Domain: sportnaptar
*/

if ( !defined( 'ABSPATH' ) ) exit;

// WordPress Plugin Directory-hoz való megfelelőség miatt szükséges belső változó.
define('SPORTNAPTAR_898_ROOT', dirname(__FILE__));
define('SPORTNAPTAR_898_REMOTE_URL', 'https://sportnaptar.hu/api.php/dataserver/event/');
define('SPORTNAPTAR_898_REMOTE_LIST_URL', 'https://sportnaptar.hu/api.php/dataserver/list/');
define('SPORTNAPTAR_898_REMOTE_CATEGORY_URL', 'https://sportnaptar.hu/api.php/dataserver/categories/');

function sportnaptar_898_update() {
    /* 
       Ha a plugint a WordPress Plugin Directory-ban is publikálnád, 
       akkor ezt az eljárást és a libs/autoupdate.php fájlt törölnöd kell!
    */

    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
    // Frissítési paraméterek beállítása
	$plugin_current_version = '2.00'; // Current version
	$plugin_remote_path     = 'https://sportnaptar.hu/wordpress/sportnaptar/update.php';  
    $plugin_slug            = plugin_basename(__file__);
	$license_user           = get_site_url();
	$license_key            = '<opcionális licensz kulcs>';

	// Csak akkor végezzen automatikus frissítést, ha a licence_felhasználó és a licenckulcs meg van adva
	if ( $license_user && $license_key && $plugin_remote_path )	{
		new sportnaptar_898_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'sportnaptar_898_update');


function sportnaptar_898_get_options() { 
	// Alapértelmezett értékek beállítása
	$defaults = array(
			'my_page'    => '',
            'cache_time' => 6,
            'hide_behind' => 0,
            'sort' => 'date',
            'template' => 'default'
		);

	// Beállított értékek beolvasása
	$options = get_option('sportnaptar_options');

	// Ha nincs beállítva, akkor az alapértelmezett érték 
	$options = wp_parse_args($options, $defaults);

	return $options;
}


function sportnaptar_898_load_textdomain() {
    // Nyelvi fájl beállítása.
    load_plugin_textdomain( 'sportnaptar', false, basename( dirname( __file__ )) . '/languages' ); 
}
add_action( 'plugins_loaded', 'sportnaptar_898_load_textdomain' );

// cURL hibaüzenet megjelenítése
function sportnaptar_898_curl_alert() {
    if( get_transient( 'sportnaptar_898_curl_alert' ) ) {
        echo '<div class="notice notice-error">'.
             '<p><strong>' . __('The cURL plugin is not available!', 'sportnaptar') . '</strong><br />'.
             __('The plugin uses this plugin for the query, so its existence is absolutely necessary.', 'sportnaptar') . 
             '</p></div>';
        delete_transient( 'sportnaptar_898_curl_alert' );
    }
}
add_action( 'admin_notices', 'sportnaptar_898_curl_alert' );


function sportnaptar_898_activation() {
    // A plugin aktiválásakor fut le
    
    // cURL rendelkezésre állásának vizsgálata
    if (!in_array('curl', get_loaded_extensions())) {    
        // Ha nem áll rendelkezésre, akkor beállítjuk a hibaüzenet megjelenítését
        set_transient( 'sportnaptar_898_curl_alert', 1 );
    }
    
	// Alapértelmezett értékek beállítása és mentése
	$options = sportnaptar_898_get_options();
	update_option('sportnaptar_options', $options, true);
    
}
register_activation_hook( __file__, 'sportnaptar_898_activation' );

function sportnaptar_898_deactivation() {
    // A plugin deaktiválásakor fut le

	// Beállítások törlése az options táblából
	delete_option('sportnaptar_options');
}
register_deactivation_hook( __file__, 'sportnaptar_898_deactivation' );

function sportnaptar_898_uninstall() {
    // A plugin törlésekor fut le
    // Megelőzően a deaktiváláskor megadottak is lefutnak.
}
register_uninstall_hook( __file__, 'sportnaptar_898_uninstall' );

function sportnaptar_898_styles_and_scripts_to_frontend(){
    
    define('SPORTNAPTAR_898_DISPLAY_LIST', 1);
    
        wp_register_style( 'sportnaptar', plugins_url( 'sportnaptar/assets/css/sportnaptar.css', SPORTNAPTAR_898_ROOT ) );
    	wp_enqueue_style( 'sportnaptar' );
        
        wp_register_script('sportnaptar-js', plugins_url( 'sportnaptar/assets/js/sportnaptar.js', SPORTNAPTAR_898_ROOT ), array('jquery'));
		wp_localize_script('sportnaptar-js', 'sportnaptar_898_wait_image_src', plugins_url( 'sportnaptar/assets/images/wait.gif', SPORTNAPTAR_898_ROOT ) );
		wp_localize_script('sportnaptar-js', 'sportnaptar_898_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('sportnaptar-js');
}

function sportnaptar_898_shortcode($args) {
    // A shortcode használatakor automatikusan hívódik meg a WordPress által

    include_once( SPORTNAPTAR_898_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'cache.php');
    include_once( SPORTNAPTAR_898_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'template.php');

    // Ha a forrás nincs a shortcode-ban definiálva, akkor hibaüzenetet írunk a forrásba és kilépünk
    if (!isset($args['url'])) {
        

    	if (!defined('SPORTNAPTAR_898_DISPLAY_LIST')) {
    		// A globális beállítások átadódnak a script-ek meghívásához
    		// Global settings are passed to invite scripts
    		sportnaptar_898_styles_and_scripts_to_frontend();
    	}

    	// Alapértelmezett plugin paraméterek betöltése
    	$options = sportnaptar_898_get_options();
        // Értékek összefésülése
        $args = wp_parse_args($args, $options);
    
        // Osztály betöltése, ha kell
        if (!class_exists('JSportnaptar898_list')) {
            include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'list.php');
        }
    
        // Az alapértelmezett paraméterekkel történik az osztály létrehozása
        $my_plugin = new JSportnaptar898_list($args);
        
    } else {
        // Módosítjuk a forrás értékét, csak az azonosítót tartjuk meg
        
        // Utolsó blokk kikeresése
        $temp = explode(DIRECTORY_SEPARATOR, $args['url']);
        $temp = $temp[count($temp)-1];
        
        // Az utolsó blokkból az azonosító kiemelése
        $temp = explode('_', $temp);
        $temp = $temp[count($temp)-1];

        $args['id'] = $temp;

    	// Alapértelmezett plugin paraméterek betöltése
    	$options = sportnaptar_898_get_options();
        // Értékek összefésülése
        $args = wp_parse_args($args, $options);
    
        // Osztály betöltése, ha kell
        if (!class_exists('JSportnaptar898_one')) {
            include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'one.php');
        }
    
        // Az alapértelmezett paraméterekkel történik az osztály létrehozása
        $my_plugin = new JSportnaptar898_one($args);
    }

    $html = $my_plugin->getContent();
    
    return $html;
}
add_shortcode('sportnaptar', 'sportnaptar_898_shortcode');


if ( is_admin() ){ 
// Csak az adminisztrációs felületen szükséges eljárások

    // A plugin beállításának osztálya betöltése
    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'sportnaptar-setup.php' );
    $my_settings_page = new sportnaptar_898_settings();
    
}

function sportnaptar_898_add_settings_link( $links ) {
    // "Beállítások" link hozzáadása a "Bővítmények" oldalon ehhez a bővítményhez
    $settings_link = '<a href="options-general.php?page=sportnaptar-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'sportnaptar_898_add_settings_link' );

function sportnaptar_898_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = sanitize_text_field($_REQUEST['page']);
    } else {
        $page = '';
    }
    // Csak akkor töltődik be, amikor ennek a pluginnak a beállításai aktuálisak.
    if (($pagenow == 'options-general.php') and ($page == 'sportnaptar-setting-admin')) {

        // Admin oldali CSS betöltése
        wp_register_style( 'sportnaptar-admin', plugins_url( 'sportnaptar/assets/css/sportnaptar-admin.css', SPORTNAPTAR_898_ROOT ) );
    	wp_enqueue_style( 'sportnaptar-admin' );
        
    	// Javascript betöltése a gyorsítótár törléséhez
        wp_register_script('sportnaptar-admin-js', plugins_url( 'sportnaptar/assets/js/sportnaptar-admin.js', SPORTNAPTAR_898_ROOT ), array('jquery'));

		// Ajax hívás engedélyezése
		wp_localize_script('sportnaptar-admin-js', 'sportnaptar_898_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('sportnaptar-admin-js');
    }
}
add_action( 'admin_enqueue_scripts', 'sportnaptar_898_styles_and_scripts_to_backend' );

// Ajax eljárások betöltése - gyorsítótás törlése
include_once(SPORTNAPTAR_898_ROOT . '/libs/ajax.php');

